package com.example.course.user.controller;

import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson2.JSONObject;
import com.example.course.user.domain.WechatUser;
import com.example.course.user.dto.WXAuth;
import com.example.course.user.service.WechatUserService;
import com.example.course.utils.Result;
//import io.swagger.annotations.Api;
//import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.net.URLEncoder;

/**
 * 微信相关接口控制器
 */
@Slf4j
@RestController
@RequestMapping("/wechat")
public class WeChatController {

    @Autowired
    private WechatUserService wechatUserService;

    @RequestMapping("/login")
    public void wx(HttpServletRequest request, HttpServletResponse response) throws IOException {
        //第一步：引导用户进入授权页面同意授权，获取code
        StringBuilder builder = new StringBuilder("https://open.weixin.qq.com/connect/oauth2/authorize?appid=");
        builder.append("wxf463750c0be078db");
        builder.append("&redirect_uri=");
        //https://5ccy.cn/guest/callBack 是自己后台的回调地址
        builder.append(URLEncoder.encode("https://5ccy.cn/guest/callBack"));
        builder.append("&response_type=code");
        builder.append("&scope=snsapi_userinfo");
        builder.append("&state=STATE#wechat_redirect");
        //授权页面地址
        //将StringBuilder转换成String
        String url = builder.toString();
        //重定向到授权页面
        response.sendRedirect(url);
    }

    /**
     * 第二步页面授权后根据上面回调地址请求到此接口上
     */
    @RequestMapping(value = "/callBack")
    public String wxcallback(@RequestParam("code") String code) throws IOException {
        System.out.println("code:" + code);
        //获取code后，请求以下链接获取access_token
        StringBuilder builder = new StringBuilder("https://api.weixin.qq.com/sns/oauth2/access_token?appid=");
        builder.append("wxf463750c0be078db");
        builder.append("&secret=");
        builder.append("beba38298a2f51c6299703dc31744e12");
        builder.append("&code=");
        builder.append(code);
        builder.append("&grant_type=authorization_code");


        String url = builder.toString();
        //通过网络请求方法来请求上面这个接口从返回的JSON数据中取出access_token和openid
        String resAccessToken = HttpUtil.get(url);
        JSONObject parse = JSONObject.parse(resAccessToken);
        String access_token = parse.getString("access_token");
        String refresh_token = parse.getString("refresh_token");
        String openid = parse.getString("openid");
        String scope = parse.getString("scope");
        Integer expiresIn = parse.getInteger("expires_in");

        //拉取用户信息(需scope为 snsapi_userinfo)
        StringBuilder builder1 = new StringBuilder("https://api.weixin.qq.com/sns/userinfo?access_token=");
        //access_token是上面返回的值
        builder1.append(access_token);
        builder1.append("&openid=");
        builder1.append(openid);
        builder1.append("&lang=zh_CN");
        //通过网络请求方法来请求上面这个接口
        String resInfo = HttpUtil.get(builder1.toString());

        return resInfo ;
    }

}
