package com.example.course.utils;

public class StringTools {

    /**
     * 判断字符串是否为空或仅包含空白字符
     *
     * @param str 要检查的字符串
     * @return 如果字符串为空或仅包含空白字符，则返回 true，否则返回 false
     */
    public static boolean isEmpty(final CharSequence str) {
        return str == null || str.length() == 0;
    }

    /**
     * 判断字符串是否为空或仅包含空白字符
     *
     * @param str 要检查的字符串
     * @return 如果字符串为空或仅包含空白字符，则返回 true，否则返回 false
     */
    public static boolean isBlank(final CharSequence str) {
        return str == null || str.length() == 0 || isWhitespace(str);
    }

    /**
     * 判断字符序列是否为空白字符
     *
     * @param cs 要检查的字符序列
     * @return 如果字符序列为空白字符，则返回 true，否则返回 false
     */
    public static boolean isWhitespace(final CharSequence cs) {
        if (cs == null) {
            return false;
        }
        for (int i = 0; i < cs.length(); i++) {
            if (!Character.isWhitespace(cs.charAt(i))) {
                return false;
            }
        }
        return true;
    }

    /**
     * 查找指定字符在字符串中首次出现的位置
     *
     * @param str    要搜索的字符串
     * @param ch     要查找的字符
     * @return 如果找到指定字符，则返回其索引，否则返回 -1
     */
    public static int indexOf(final String str, final char ch) {
        if (str == null) {
            return -1;
        }
        return str.indexOf(ch);
    }
}
