package com.example.course;

import java.io.*;
import java.net.Socket;
import java.util.Scanner;

public class SocketClient {
    public static void main(String[] args) {
        // 客户端
        Socket socket = null;
        try{
            // 连接服务端
            socket = new Socket("127.0.0.1",1024);
            // 获取输出流
            OutputStream outputStream = socket.getOutputStream();
            // 将输出流包装为打印流
            PrintWriter printWriter = new PrintWriter(outputStream);
            System.out.println("请输入内容");

            // 创建线程,用于从控制台获取数据
            new Thread(()->{
                while(true){
                    try{
                        // 从控制台获取输入
                        Scanner scanner = new Scanner(System.in);
                        // 发送数据
                        String input = scanner.nextLine();
                        // 发送数据
                        printWriter.println(input);
                        // 刷新缓冲区
                        printWriter.flush();
                    }catch (Exception e){
                        e.printStackTrace();
                        break;
                    }
                }
            }).start();

            // 获取输入流
            InputStream inputStream = socket.getInputStream();
            // 将输入流包装为字符流
            InputStreamReader reader = new InputStreamReader(inputStream,"UTF-8");
            // 将字符流包装为缓冲流
            BufferedReader bufferedReader = new BufferedReader(reader);

            // 创建线程,用于读取服务端发送的数据
            new Thread(()->{
                while (true){
                    try{
                        // 读取数据
                        String readData = bufferedReader.readLine();
                        System.out.println("收到服务端消息"+readData);
                    }catch (Exception e){
                        e.printStackTrace();
                        break;
                    }
                }
            }).start();
        }catch (Exception e){
            e.printStackTrace();
        }
    }
}
