package com.example.course;

import java.io.*;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.HashMap;
import java.util.Map;
import java.util.TreeMap;

/**
 * @author 11
 */
public class SocketService {
    public static void main(String[] args) {
        // 服务端
        ServerSocket server = null;
        Map<String,Socket> clientMap = new HashMap<>();
        try {
            // 绑定端口
            server = new ServerSocket(1024);
            System.out.println("服务已启动,等待客户端连接");
            while(true){
                // 阻塞等待客户端连接
                Socket socket = server.accept();
                // 获取客户端ip
                String ip = socket.getInetAddress().getHostAddress();
                System.out.println("有客户端连接ip:"+ip+"端口:"+socket.getPort());
                String clientKey = ip+socket.getPort();
                clientMap.put(clientKey,socket);
                new Thread(()->{
                    while(true){
                        try {
                            // 获取输入流
                            InputStream inputStream = socket.getInputStream();
                            // 将输入流包装为字符流
                            InputStreamReader reader = new InputStreamReader(inputStream);
                            // 将字符流包装为缓冲流
                            BufferedReader bufferedReader = new BufferedReader(reader);
                            // 读取数据
                            String readData = bufferedReader.readLine();
                            System.out.println("收到客户端消息->"+readData);

                            clientMap.forEach((k,v)->{
                                try{
                                    OutputStream outputStream = v.getOutputStream();
                                    PrintWriter printWriter = new PrintWriter(new OutputStreamWriter(outputStream,"UTF-8"));
                                    printWriter.println(socket.getPort() + ":" + readData);
                                    printWriter.flush();
                                }catch (Exception e){
                                    e.printStackTrace();
                                }
                            });
                        }catch (Exception e){
                            e.printStackTrace();
                            break;
                        }
                    }
                }).start();
            }

        }catch (Exception e){
            e.printStackTrace();
        }
    }
}
